#pragma -w2

#include "hmg.ch"

MEMVAR _HMG_SYSDATA, aFiles, nFieldSort, nItem_ID, aux_ID, hChangeHandle, cFolderHMG, nBuildBAT, nOpenHBP, cHMG_Help, hBitmap
MEMVAR aForeColorHBP, aBackColorHBP, aFontTypeHBP
MEMVAR aForeColorPRG, aBackColorPRG, aFontTypePRG

#xtranslate cDEFAULT_FolderHMG => "C:\hmg.3.3.1"

#xtranslate cFILENAME_INI      => GetStartUpFolder() + "\HMG_EasyBuild.ini"

#xtranslate BUILD32_BAT   => "Build.bat"
#xtranslate BUILD64_BAT   => "Build64.bat"

#xtranslate IDE_ANSI    (<cFolder>) => <cFolder> + "\IDE_ANSI\IDE_ANSI.EXE"
#xtranslate IDE_UNICODE (<cFolder>) => <cFolder> + "\IDE\IDE.EXE"
#xtranslate URL_HELP    (<cFolder>) => "file:///" + <cFolder> + "/DOC/data/index.htm"

#xtranslate URL_BLOG   => "http://srvet.blogspot.com"
#xtranslate URL_FORUM  => "http://www.hmgforum.com"

#xtranslate URL_OPEN (<cURL>)    => ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler " + <cURL>, NIL, 1)


#define _VERSION   " [ ver. 1.0 ]"


FUNCTION MAIN
LOCAL  cCSIDL_Name := NIL, nIndexRoot := NIL
PUBLIC hChangeHandle := 0
PUBLIC aFiles := NIL
PUBLIC nFieldSort := BT_DIRECTORYINFO_NAME
PRIVATE nItem_ID := 1
PRIVATE aux_ID := -1

PUBLIC cFolderHMG := cDEFAULT_FolderHMG
PUBLIC nBuildBAT  := 1
PUBLIC nOpenHBP   := 1

PRIVATE cHMG_Help := URL_HELP ( cFolderHMG )

PUBLIC hBitmap := 0

PUBLIC aForeColorHBP := BLUE
PUBLIC aBackColorHBP := NIL //GRAY
PUBLIC aFontTypeHBP  := ARRAY FONT "Calibri" SIZE 11 BOLD ITALIC

PUBLIC aForeColorPRG := RED
PUBLIC aBackColorPRG := NIL //GRAY
PUBLIC aFontTypePRG  := ARRAY FONT "Calibri" SIZE 11 BOLD ITALIC

   SETTING_Load()

   SET FONT TO "Calibri", 11

   DEFINE WINDOW Form_1;
      AT 0,0;
      WIDTH 800;
      HEIGHT 600;
      TITLE 'HMG Easy Build' + _VERSION;
      ICON "_EasyBuild_Icon.ico";
      ON PAINT SPLITBOX_RESIZE();
      ON RELEASE (Form_1.Tree_1.ImageList := 0, Form_1.Grid_1.ImageList := 0 );   // avoid release System Icon ImageList
      MAIN 

      DEFINE STATUSBAR
            STATUSITEM "" ACTION IF (.NOT. EMPTY (Form_1.StatusBar.Item(1)),( System.Clipboard := Form_1.StatusBar.Item(1), MsgInfo (Form_1.StatusBar.Item(1),"Copied to the clipboard")), NIL)
      END STATUSBAR
      
   DEFINE SPLITBOX

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 120,95 IMAGESIZE 64,64 STRICTWIDTH FLAT
         BUTTON Button_1 CAPTION "Ho&me"            PICTURE '_home'    ACTION URL_OPEN ( URL_BLOG  ) TOOLTIP 'Home page ...'
         BUTTON Button_3 CAPTION "HMG &Help"        PICTURE '_help'    ACTION URL_OPEN ( cHMG_Help ) TOOLTIP 'Open HMG Help'
         BUTTON Button_2 CAPTION "HMG &Forum"       PICTURE '_ftp'     ACTION SEARCH_OPEN() TOOLTIP 'Open HMG Forum'
         BUTTON Button_4 CAPTION "&Setting Options" PICTURE '_setting' ACTION SETTING_OPTIONS()      TOOLTIP 'Setting Options'
         BUTTON Button_5 CAPTION "&Open File"       PICTURE '_open'    ACTION OPEN_FILE()            TOOLTIP 'Open File'
         BUTTON Button_6 CAPTION "&Build App"       PICTURE '_build'   ACTION BUILD_APP()            TOOLTIP 'Build .HBP/.PRG Files'
         BUTTON Button_7 CAPTION "&About"           PICTURE '_about'   ACTION ABOUT_INFO()           TOOLTIP 'About ...'
      END TOOLBAR


      DEFINE TREE Tree_1; 
             WIDTH  300;
             HEIGHT 400;
             ON GOTFOCUS ( Form_1.StatusBar.IconHandle(1) := BT_ImageListExtractIcon (Form_1.Tree_1.ImageList,Form_1.Tree_1.ImageIndex (Form_1.Tree_1.Value)[1]),; 
                           Form_1.StatusBar.Item(1)       := IF (Form_1.Tree_1.Value == Form_1.Tree_1.RootValue, Form_1.Tree_1.Item(Form_1.Tree_1.Value), Form_1.Tree_1.Cargo(Form_1.Tree_1.Value)));
             ON CHANGE Tree_OnClick();
             ON EXPAND     ADD_FOLDER (This.TreeItemValue);
             ON DBLCLICK ( ADD_FOLDER (Form_1.Tree_1.Value), DISPLAY_FILES (Form_1.Tree_1.Value) );
             ITEMIDS

            DEFINE NODE "My Computer" IMAGES Nil   ID nItem_ID++
            END NODE
      END TREE


      Form_1.Tree_1.HasLines      := .F.
      Form_1.Tree_1.FullRowSelect := .T.

      Form_1.Tree_1.Cargo (Form_1.Tree_1.RootValue) := CSIDL_DRIVES   // My Computer

      BT_DirectoryInfo ( Form_1.Tree_1.Cargo (Form_1.Tree_1.RootValue), BT_DIRECTORYINFO_INFOROOT, @nIndexRoot, @cCSIDL_Name )

      Form_1.Tree_1.Item (Form_1.Tree_1.RootValue)       := cCSIDL_Name
      Form_1.Tree_1.ImageIndex (Form_1.Tree_1.RootValue) := { nIndexRoot , nIndexRoot }

      ADD_FOLDER (Form_1.Tree_1.RootValue)
      Form_1.Tree_1.Expand (Form_1.Tree_1.RootValue)


      GRID Grid_1 ;
         WIDTH 760 ;
         HEIGHT 400;
         HEADERS {'Name','Date Modified','Type',"Size","FullName"};
         WIDTHS  {   300,            150,   150,   100,       450};
         ITEMS   NIL;
         NOLINES;
         HEADERIMAGES {"","","","",""};
         ;//ON CHANGE (SetStatusItemIcon (Form_1.StatusBar.HANDLE, 0, NIL, BT_ImageListExtractIcon (Form_1.Grid_1.ImageList,Form_1.Grid_1.ImageIndex (Form_1.Grid_1.Value, 1))), Form_1.StatusBar.Item(1) := Form_1.Grid_1.CellEx (Form_1.Grid_1.Value,5));
         ON DBLCLICK ( OPEN_FOLDER() , DISPLAY_FILES (Form_1.Tree_1.Value) )

         Form_1.Grid_1.ColumnJUSTIFY          (4) := GRID_JTFY_RIGHT

         Form_1.Grid_1.ColumnDYNAMICFONT      (1) := {|| IF ( IsHMGFile() == 1, aFontTypeHBP,  IF ( IsHMGFile() == 2, aFontTypePRG, NIL )) }

         Form_1.Grid_1.ColumnDYNAMICFORECOLOR (1) := {|| IF ( IsHMGFile() == 1, aForeColorHBP, IF ( IsHMGFile() == 2, aForeColorPRG, BLACK)) }
         Form_1.Grid_1.ColumnDYNAMICFORECOLOR (2) := {|| IF ( IsHMGFile() == 1, aForeColorHBP, IF ( IsHMGFile() == 2, aForeColorPRG, GRAY )) }
         Form_1.Grid_1.ColumnDYNAMICFORECOLOR (3) := {|| IF ( IsHMGFile() == 1, aForeColorHBP, IF ( IsHMGFile() == 2, aForeColorPRG, GRAY )) }
         Form_1.Grid_1.ColumnDYNAMICFORECOLOR (4) := {|| IF ( IsHMGFile() == 1, aForeColorHBP, IF ( IsHMGFile() == 2, aForeColorPRG, GRAY )) }
         Form_1.Grid_1.ColumnDYNAMICFORECOLOR (5) := {|| IF ( IsHMGFile() == 1, aForeColorHBP, IF ( IsHMGFile() == 2, aForeColorPRG, GRAY )) }

         Form_1.Grid_1.ColumnDYNAMICBACKCOLOR (1) := {|| IF ( IsHMGFile() == 1, aBackColorHBP, IF ( IsHMGFile() == 2, aBackColorPRG, NIL  )) }
         Form_1.Grid_1.ColumnDYNAMICBACKCOLOR (2) := {|| IF ( IsHMGFile() == 1, aBackColorHBP, IF ( IsHMGFile() == 2, aBackColorPRG, NIL  )) }
         Form_1.Grid_1.ColumnDYNAMICBACKCOLOR (3) := {|| IF ( IsHMGFile() == 1, aBackColorHBP, IF ( IsHMGFile() == 2, aBackColorPRG, NIL  )) }
         Form_1.Grid_1.ColumnDYNAMICBACKCOLOR (4) := {|| IF ( IsHMGFile() == 1, aBackColorHBP, IF ( IsHMGFile() == 2, aBackColorPRG, NIL  )) }
         Form_1.Grid_1.ColumnDYNAMICBACKCOLOR (5) := {|| IF ( IsHMGFile() == 1, aBackColorHBP, IF ( IsHMGFile() == 2, aBackColorPRG, NIL  )) }

         Form_1.Grid_1.ColumnONHEADCLICK (1) := {|| SORT_FILES ( BT_DIRECTORYINFO_NAME ) }
         Form_1.Grid_1.ColumnONHEADCLICK (2) := {|| SORT_FILES ( BT_DIRECTORYINFO_INTERNALDATA_DATE ) }
         Form_1.Grid_1.ColumnONHEADCLICK (3) := {|| SORT_FILES ( BT_DIRECTORYINFO_TYPE ) }

   END SPLITBOX

   Form_1.Tree_1.ImageList := BT_ImageListGetSystemIcon()
   Form_1.Grid_1.ImageList := BT_ImageListGetSystemIcon()

   SetWindowTheme  (Form_1.Tree_1.HANDLE, "Explorer", NIL)
   SetWindowTheme  (Form_1.Grid_1.HANDLE, "Explorer", NIL)
   SetWindowCursor (Form_1.Tree_1.HANDLE, IDC_HAND)

   SORT_FILES ( nFieldSort )

   END WINDOW

   MAXIMIZE WINDOW Form_1
   ACTIVATE WINDOW Form_1

RETURN NIL


*-----------------------------------------------------------------------------*
PROCEDURE SPLITBOX_RESIZE
*-----------------------------------------------------------------------------*
LOCAL Height    := BT_ClientAreaHeight ("Form_1") - BT_StatusBarHeight ("Form_1")
LOCAL DifHeight := Height - REBAR_GETHEIGHT (GetSplitBoxHandle("Form_1"))
LOCAL aRect     := REBAR_GETBANDINFO (GetSplitBoxHandle("Form_1"), 1)   // Tree
LOCAL NewHeight := aRect [2] + DifHeight
   REBAR_SETMINCHILDSIZE (GetSplitBoxHandle("Form_1"), 1, NewHeight)   // Tree
   REBAR_SETMINCHILDSIZE (GetSplitBoxHandle("Form_1"), 2, NewHeight)   // Grid
RETURN


*-----------------------------------------------------------------------------*
FUNCTION Tree_OnClick()
*-----------------------------------------------------------------------------*
LOCAL hWnd := 0
   IF HMG_GetLastMouseMessage (@hWnd) == WM_LBUTTONUP .AND. hWnd == Form_1.Tree_1.HANDLE
      HMG_CleanLastMouseMessage()
      ADD_FOLDER (Form_1.Tree_1.Value)
      DISPLAY_FILES (Form_1.Tree_1.Value) 
   ENDIF
RETURN NIL


*-----------------------------------------------------------------------------*
PROCEDURE OPEN_FOLDER
*-----------------------------------------------------------------------------*
LOCAL nValue

   IF ValType(aFiles) <> "A" .OR. Form_1.Grid_1.CellRowFocused <= 0
      RETURN
   ENDIF

   IF aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_INTERNALDATA_TYPE] <> BT_DIRECTORYINFO_INTERNALDATA_NOFOLDER
      IF Form_1.Tree_1.IsExpand (Form_1.Tree_1.Value) == .F.
         Form_1.Tree_1.Expand (Form_1.Tree_1.Value)
      ENDIF
      nValue := Form_1.Tree_1.CargoScan ( aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME] )
      IF nValue <> NIL
         Form_1.Tree_1.Value := nValue
      ENDIF
   ENDIF

RETURN


*-----------------------------------------------------------------------------*
PROCEDURE ADD_FOLDER ( nValue )
*-----------------------------------------------------------------------------*
LOCAL i, aFolders
LOCAL nImageIndex := 0
LOCAL parent_ID 

   IF (Form_1.Tree_1.NodeFlag (nValue) == .T.) .AND. (Form_1.Tree_1.IsTrueNode (nValue) == .T.) .OR. (nValue == NIL) .OR. (nValue <= 0)
      RETURN
   ENDIF

   SetCursorSystem (IDC_WAIT)

   parent_ID := nValue
   aFolders := BT_DirectoryInfo ( Form_1.Tree_1.Cargo (nValue), BT_DIRECTORYINFO_LISTFOLDER )
   IF ValType (aFolders) <> "A"
      SetCursorSystem (IDC_ARROW)
      RETURN
   ENDIF


   FOR i = 1 TO HMG_LEN (aFolders)
      IF i == 1
         Form_1.Tree_1.NodeFlag (parent_ID) := .T.
      ENDIF
      Form_1.Tree_1.AddItem ( aFolders [i] [BT_DIRECTORYINFO_NAME], parent_ID, nItem_ID)
      IF aFolders [i] [BT_DIRECTORYINFO_INTERNALDATA_TYPE] == BT_DIRECTORYINFO_INTERNALDATA_HASSUBFOLDER   // Folder with Sub-Folder
         Form_1.Tree_1.HasButton ( nItem_ID ) := .T.
      ENDIF
      Form_1.Tree_1.NodeFlag ( nItem_ID ) := .F.
      nImageIndex := aFolders [i] [BT_DIRECTORYINFO_INTERNALDATA_IMAGEINDEX]
      Form_1.Tree_1.ImageIndex ( nItem_ID ) := { nImageIndex , nImageIndex }
      Form_1.Tree_1.Cargo ( nItem_ID ) := aFolders [i] [BT_DIRECTORYINFO_FULLNAME]
      nItem_ID ++
   NEXT

   TREESORT Tree_1 OF Form_1   ITEM parent_ID   RECURSIVE .F.   CASESENSITIVE .F.   ASCENDINGORDER .T.   NODEPOSITION TREESORTNODE_MIX

   SetCursorSystem (IDC_ARROW)

RETURN


*-----------------------------------------------------------------------------*
PROCEDURE DISPLAY_FILES (nValue)
*-----------------------------------------------------------------------------*
LOCAL nNotifyFilter

   IF nValue <> NIL
      Form_1.StatusBar.IconHandle(1) := BT_ImageListExtractIcon (Form_1.Tree_1.ImageList,Form_1.Tree_1.ImageIndex (nValue)[1])
      Form_1.StatusBar.Item(1) := IF (nValue == Form_1.Tree_1.RootValue, Form_1.Tree_1.Item (nValue), Form_1.Tree_1.Cargo (nValue))
   ENDIF

   IF nValue == NIL .OR. nValue < 0
      RETURN
   ENDIF

   IF IsControlDefined (Timer_1, Form_1)
      Form_1.Timer_1.RELEASE
   ENDIF

   IF hChangeHandle <> 0
      FindCloseChangeNotification (hChangeHandle)
      hChangeHandle := 0
   ENDIF

   nNotifyFilter := hb_bitOR (FILE_NOTIFY_CHANGE_FILE_NAME, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_NOTIFY_CHANGE_LAST_WRITE)

   hChangeHandle  := FindFirstChangeNotification (Form_1.Tree_1.Cargo (nValue), .F., nNotifyFilter)

   SetCursorSystem (IDC_WAIT)

   IF Form_1.Tree_1.RootValue == nValue
      aFiles := BT_DirectoryInfo ( CSIDL_DESKTOPDIRECTORY,       BT_DIRECTORYINFO_LISTALL )
   ELSE
      aFiles := BT_DirectoryInfo ( Form_1.Tree_1.Cargo (nValue), BT_DIRECTORYINFO_LISTALL )
   ENDIF

   SORT_FILES ( nFieldSort )

   SetCursorSystem (IDC_ARROW)

   DEFINE TIMER Timer_1 OF Form_1 INTERVAL 800 ACTION CHANGE_FILES()

RETURN


*-----------------------------------------------------------------------------*
PROCEDURE SORT_FILES ( nIndexSort )
*-----------------------------------------------------------------------------*
LOCAL i, aItem, nCol := 0
LOCAL cFullPath := NIL, nRowFocus := 0

   nFieldSort := nIndexSort
   DO CASE
      CASE nFieldSort == BT_DIRECTORYINFO_NAME
           nCol := 1
      CASE nFieldSort == BT_DIRECTORYINFO_INTERNALDATA_DATE
           nCol := 2
      CASE nFieldSort == BT_DIRECTORYINFO_TYPE
           nCol := 3
   ENDCASE

   Form_1.Grid_1.HeaderImages ( nCol ) := "_check"
   Form_1.Grid_1.HeaderImageIndex ( nCol ) := 0
   FOR i := 1 TO Form_1.Grid_1.ColumnCount
      IF nCol <> i
         Form_1.Grid_1.HeaderImageIndex ( i ) := -1
      ENDIF
   NEXT

   IF ValType (aFiles) <> "A"
      Form_1.Grid_1.DeleteAllItems
      RETURN
   ENDIF

   SetCursorSystem (IDC_WAIT)

   IF Form_1.Grid_1.CellRowFocused > 0
      cFullPath := Form_1.Grid_1.CellEx (Form_1.Grid_1.CellRowFocused, 5)
   ENDIF

   Form_1.Grid_1.DeleteAllItems

   ASORT (aFiles, NIL, NIL, { |x, y| IF (HMG_StrCmp ( ;
                      (HB_USUBSTR(ALLTRIM(x[BT_DIRECTORYINFO_INTERNALDATA_TYPE]),1,1) + x[nIndexSort] + x[BT_DIRECTORYINFO_NAME]) ,; 
                      (HB_USUBSTR(ALLTRIM(y[BT_DIRECTORYINFO_INTERNALDATA_TYPE]),1,1) + y[nIndexSort] + y[BT_DIRECTORYINFO_NAME]) ,;
                      .F. ) < 0, .T., .F.) })

   Form_1.Grid_1.DisableUpdate
   FOR i = 1 TO HMG_LEN (aFiles)
      aItem := { aFiles [i] [BT_DIRECTORYINFO_NAME],; 
                 aFiles [i] [BT_DIRECTORYINFO_DATE],; 
                 aFiles [i] [BT_DIRECTORYINFO_TYPE],; 
                 aFiles [i] [BT_DIRECTORYINFO_SIZE],; 
                 aFiles [i] [BT_DIRECTORYINFO_FULLNAME];
               }
              // aFiles [i] [BT_DIRECTORYINFO_INTERNALDATA_TYPE], 
              // aFiles [i] [BT_DIRECTORYINFO_INTERNALDATA_DATE], 
              // HB_NTOS(aFiles [i] [BT_DIRECTORYINFO_INTERNALDATA_IMAGEINDEX]) 
      Form_1.Grid_1.AddItem (aItem)
      Form_1.Grid_1.ImageIndex (i,1) := aFiles [i] [BT_DIRECTORYINFO_INTERNALDATA_IMAGEINDEX]
      IF cFullPath == aFiles [i] [BT_DIRECTORYINFO_FULLNAME]
         nRowFocus := i
      ENDIF
   NEXT
   Form_1.Grid_1.ColumnWIDTH (5) := GRID_WIDTH_AUTOSIZE
   Form_1.Grid_1.Value := nRowFocus
   Form_1.Grid_1.EnableUpdate

   SetCursorSystem (IDC_ARROW)

RETURN


*-----------------------------------------------------------------------------*
PROCEDURE CHANGE_FILES
*-----------------------------------------------------------------------------*
STATIC Flag := .F.
LOCAL dwWaitStatus
   
   IF Flag == .T.
      RETURN
   ENDIF
   Flag := .T.

   dwWaitStatus = WaitForSingleObject (hChangeHandle, 0)
   IF dwWaitStatus == WAIT_OBJECT_0
      FindNextChangeNotification (hChangeHandle)
      DISPLAY_FILES (Form_1.Tree_1.Value)
   ENDIF
   Flag := .F.
RETURN


***********************************************************************************
FUNCTION IsHMGFile
***********************************************************************************
LOCAL cFullName, cExt := NIL

   IF ValType(aFiles) <> "A"
      RETURN 0
   ENDIF

   IF aFiles [This.CellRowIndex] [BT_DIRECTORYINFO_INTERNALDATA_TYPE] == BT_DIRECTORYINFO_INTERNALDATA_NOFOLDER
      cFullName := aFiles [This.CellRowIndex] [BT_DIRECTORYINFO_FULLNAME]
      HB_FNameSplit (cFullName, NIL, NIL, @cExt, NIL)
      cExt := HMG_UPPER (cExt)
      IF cExt == ".HBP"
         RETURN 1
      ELSEIF  cExt == ".PRG"
         RETURN 2
      ENDIF
   ENDIF
RETURN 0


***********************************************************************************
PROCEDURE OPEN_FILE
***********************************************************************************
LOCAL cExt, cPath, cFullName, INI_EDITOR, IDE_EDITOR

   IF ValType(aFiles) <> "A" .OR. Form_1.Grid_1.CellRowFocused <= 0
      RETURN
   ENDIF

   IF aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_INTERNALDATA_TYPE] == BT_DIRECTORYINFO_INTERNALDATA_NOFOLDER

      cFullName := aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME]
      HB_FNameSplit (cFullName, @cPath, NIL, @cExt, NIL)
      cExt := HMG_UPPER (cExt)
      IF cExt == ".HBP"
         DO CASE
            CASE nOpenHBP == 2
                 ShellExecute(0, "open", IDE_ANSI (cFolderHMG), aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME], cPath, 1)
                 RETURN
            CASE nOpenHBP == 3
                 ShellExecute(0, "open", IDE_UNICODE (cFolderHMG), aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME], cPath, 1)
                 RETURN
         END CASE
      ENDIF
      IF cExt == ".PRG"
         INI_EDITOR := IF(nOpenHBP==2,cFolderHMG+"\IDE_ANSI\",cFolderHMG+"\IDE\")+"editor.ini"
         IDE_EDITOR := memoread( INI_EDITOR )
         IF FILE(IDE_EDITOR)
            ShellExecute(0, "open", IDE_EDITOR, aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME], cPath, 1)
            RETURN
         ENDIF
      ENDIF

      ShellExecute(0, "open", aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME], NIL, cPath, 1)
   ENDIF

RETURN


***********************************************************************************
PROCEDURE BUILD_APP
***********************************************************************************
LOCAL cBuildBAT, cFullName, cPath := NIL, cExt := NIL

   IF ValType(aFiles) <> "A" .OR. Form_1.Grid_1.CellRowFocused <= 0
      RETURN
   ENDIF
   
   IF aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_INTERNALDATA_TYPE] == BT_DIRECTORYINFO_INTERNALDATA_NOFOLDER
   
      cFullName := aFiles [Form_1.Grid_1.CellRowFocused] [BT_DIRECTORYINFO_FULLNAME]
      HB_FNameSplit (cFullName, @cPath, NIL, @cExt, NIL)

      cExt := HMG_UPPER (cExt)
      IF (cExt == ".HBP") .OR. (cExt == ".PRG")
         cBuildBAT := IF (nBuildBAT == 1, BUILD32_BAT, BUILD64_BAT)
         ShellExecute (0, "open", cFolderHMG + "\" + cBuildBAT, cFullName, cPath, 1)
      ELSE
         MsgExclamation (cFullName + " is not .HBP or .PRG file", HMG_UPPER (cExt) + " file")
      ENDIF

   ENDIF

RETURN


***********************************************************************************
PROCEDURE SETTING_OPTIONS
***********************************************************************************
LOCAL nWidth, nInc := 20, cFolderHMG_aux := cFolderHMG

   DEFINE WINDOW Form_2;
         AT 0,0;
         WIDTH  400;
         HEIGHT 450;
         TITLE 'Setting Options';
         ICON  '';
         MODAL;
         NOSIZE

      nWidth := Form_2.ClientAreaWidth

      @ 20, nInc        FRAME   Frame_1  CAPTION "HMG path library:" WIDTH (nWidth - nInc*2)      HEIGHT 50 BOLD
      @ 40, nInc + 10   TEXTBOX Text_1   VALUE   cFolderHMG          WIDTH (nWidth - nInc*2 - 50) HEIGHT 20 READONLY
      @ 35, nWidth - 55 BUTTON  Button_1 PICTURE "_open_folder"      WIDTH  30                    HEIGHT 30 ACTION (Form_2.Text_1.VALUE := SETTING_Folder(), cFolderHMG_aux := Form_2.Text_1.VALUE)

      @ 100, nInc      FRAME      Frame_2       CAPTION "Build in:" WIDTH (nWidth - nInc*2) HEIGHT 80 BOLD
      @ 120, nInc + 20 RADIOGROUP RadioGroup_1  OPTIONS {'32 bits','64 bits'}  VALUE nBuildBAT

      @ 210, nInc      FRAME      Frame_3       CAPTION "Open .HBP file with:" WIDTH (nWidth - nInc*2) HEIGHT 110 BOLD
      @ 230, nInc + 20 RADIOGROUP RadioGroup_2  OPTIONS {'Default program','IDE ANSI','IDE Unicode'} VALUE nOpenHBP

      @ 350, nInc BUTTON  Button_2 CAPTION "Save"   PICTURE "_save"   LEFT  WIDTH 100 HEIGHT 30  ACTION (SETTING_Save (cFolderHMG_aux), Form_2.Release)
      @ 350, 150  BUTTON  Button_3 CAPTION "Apply"  PICTURE "_check"  LEFT  WIDTH 100 HEIGHT 30  ACTION (cFolderHMG := cFolderHMG_aux, nBuildBAT := Form_2.RadioGroup_1.VALUE, nOpenHBP := Form_2.RadioGroup_2.VALUE, Form_2.Release)
      @ 350, 275  BUTTON  Button_4 CAPTION "Cancel" PICTURE "_cancel" LEFT  WIDTH 100 HEIGHT 30  ACTION Form_2.Release

   END WINDOW

   Form_2.Button_4.SetFocus

   CENTER WINDOW Form_2
   ACTIVATE WINDOW Form_2

RETURN


FUNCTION SETTING_Folder
LOCAL i, aFileExist := ARRAY (4), cMsg := "", cFolderHMG_aux
   cFolderHMG_aux := GetFolder ("Set HMG path library:", cFolderHMG, NIL, .F.)
   IF EMPTY (cFolderHMG_aux)
      RETURN cFolderHMG
   ENDIF
   aFileExist [1] := FILE ( cFolderHMG_aux +"\"+ BUILD32_BAT )
   aFileExist [2] := FILE ( cFolderHMG_aux +"\"+ BUILD64_BAT )
   aFileExist [3] := FILE ( IDE_ANSI    (cFolderHMG_aux) )
   aFileExist [4] := FILE ( IDE_UNICODE (cFolderHMG_aux) )
   FOR i = 1 TO HMG_LEN (aFileExist)
      IF aFileExist [i] == .F.
         cMsg := cMsg + BUILD32_BAT    + " : " + IF (aFileExist [1], "OK", "Not Found") + HB_OsNewLine()
         cMsg := cMsg + BUILD64_BAT    + " : " + IF (aFileExist [2], "OK", "Not Found") + HB_OsNewLine()
         cMsg := cMsg + "IDE ANSI"     + " : " + IF (aFileExist [3], "OK", "Not Found") + HB_OsNewLine()
         cMsg := cMsg + "IDE UNICODE"  + " : " + IF (aFileExist [4], "OK", "Not Found") + HB_OsNewLine()
         MsgExclamation ( cMsg , "Warning" )
         EXIT
      ENDIF
   NEXT
RETURN cFolderHMG_aux


PROCEDURE SETTING_Save ( cFolderHMG_aux )
   cFolderHMG := cFolderHMG_aux
   nBuildBAT  := Form_2.RadioGroup_1.VALUE
   nOpenHBP   := Form_2.RadioGroup_2.VALUE

   BEGIN INI FILE cFILENAME_INI
      SET SECTION "CONFIGURATION"   ENTRY "FolderHMG"   TO cFolderHMG
      SET SECTION "CONFIGURATION"   ENTRY "BuildBAT"    TO nBuildBAT
      SET SECTION "CONFIGURATION"   ENTRY "OpenHBP"     TO nOpenHBP
    END INI
RETURN


PROCEDURE SETTING_Load
   IF FILE (cFILENAME_INI)
      BEGIN INI FILE cFILENAME_INI
         GET cFolderHMG   SECTION "CONFIGURATION"   ENTRY "FolderHMG"   DEFAULT cDEFAULT_FolderHMG
         GET nBuildBAT    SECTION "CONFIGURATION"   ENTRY "BuildBAT"    DEFAULT 1
         GET nOpenHBP     SECTION "CONFIGURATION"   ENTRY "OpenHBP"     DEFAULT 1
      END INI
    ENDIF
RETURN


***********************************************************************************
PROCEDURE ABOUT_INFO
***********************************************************************************
STATIC lShow := .F.
LOCAL Radius, AngleDegrees, nRow, nCol
LOCAL aBackColor := PINK
LOCAL hBitmap_aux

   IF IsWindowDefined (Form_3) == .F.

      lShow := .T.
      hBitmap_aux := BT_BitmapLoadFile ("_Horse_Logo")
      hBitmap := BT_BitmapCopyAndResize (hBitmap_aux, 300, 300)
      BT_BitmapRelease (hBitmap_aux)

      DEFINE WINDOW Form_3;
            AT 0,0;
            WIDTH  430;
            HEIGHT 430;
            TOPMOST;
            NOAUTORELEASE;
            NOSIZE;
            NOCAPTION;
            BACKCOLOR aBackColor;
            ON RELEASE BT_BitmapRelease (hBitmap);
            ON PAINT   Proc_ON_PAINT_ABOUT_INFO ()
          
            Form_3.BackColorTransparent := aBackColor

            Radius := BT_ClientAreaWidth("Form_3") / 2
            AngleDegrees := 45
      
            nRow := Radius - BT_MathCircumferenceY (Radius, AngleDegrees)
            nCol := Radius + BT_MathCircumferenceX (Radius, AngleDegrees)

            @ nRow, nCol-10 BUTTON Button_2 PICTURE "_close" WIDTH 35 HEIGHT 35 ACTION (lShow := .F., Form_3.Hide)
            
      END WINDOW

      CENTER WINDOW Form_3
      ACTIVATE WINDOW Form_3

   ELSE

      IF lShow == .F.
         Form_3.Show
         lShow := .T.
      ELSE
         Form_3.Hide
         lShow := .F.
      ENDIF

   ENDIF

RETURN


***********************************************************************************
PROCEDURE Proc_ON_PAINT_ABOUT_INFO
***********************************************************************************
LOCAL Width  := BT_ClientAreaWidth  ("Form_3")
LOCAL Height := BT_ClientAreaHeight ("Form_3")
LOCAL hDC, BTstruct, i
LOCAL ch, cText, cFontName, nFontSize, nTypeText, aTextSize, nRow, nCol
LOCAL hRgn1, hRgn2, hRgnDest, nOrientation, AngleDegrees, AngleInc, Radius, OFFSET

   hDC := BT_CreateDC ("Form_3", BT_HDC_INVALIDCLIENTAREA, @BTstruct)

      OFFSET := 10
      hRgn1 = BT_RegionCreateElliptic (0 + OFFSET, 0 + OFFSET, Width - OFFSET, Height - OFFSET)
      hRgn2 = BT_RegionCreateElliptic (0, 0, Width, Height)

      BT_SelectObject (hDC, hRgn1)
      
      BT_DrawGradientFillVertical (hDC, 0, 0, Width, Height, ORANGE, {255,255,128})
      nRow := (Height - BT_BitmapHeight (hBitmap)) / 2 
      nCol := (Width  - BT_BitmapWidth  (hBitmap)) / 2
      BT_DrawBitmapTransparent (hDC, nRow, nCol, NIL, NIL, BT_SCALE, hBitmap)
      
      cText := "HMG Easy Build"
      cFontName := "Times New Roman"
      nFontSize := 24
      nTypeText := BT_TEXT_BOLD + BT_TEXT_TRANSPARENT

      OFFSET := BT_DrawTextSize (hDC, "ABC", cFontName, nFontSize, nTypeText)[2] * 1.5
      Radius := Width / 2 - OFFSET
      
/*      
      OFFSET2 := BT_DrawTextSize (hDC, "ABC", cFontName, nFontSize, nTypeText)[2] * 1.2
      Radius2 := Width / 2 - OFFSET2
      BT_DrawEllipse (hDC, 0+OFFSET2, 0+OFFSET2, Radius2*2, Radius2*2, RED, 1) 
      BT_DrawLine (hDC, 0, 0, Height, Width, ORANGE, 1)
      BT_DrawLine (hDC, Height, 0, 0, Width, ORANGE, 1)
      BT_DrawLine (hDC, Height/2, 0, Height/2, Width, ORANGE, 1)
*/

      AngleDegrees := 135
      nOrientation := AngleDegrees - 90
      
      FOR i := 1 TO HMG_LEN (cText)
         ch := HB_USUBSTR (cText, i, 1)
         nRow := Radius - BT_MathCircumferenceY (Radius, AngleDegrees) + OFFSET
         nCol := Radius + BT_MathCircumferenceX (Radius, AngleDegrees) + OFFSET
         BT_DrawText (hDC, nRow, nCol, ch, cFontName, nFontSize, BLACK, NIL, nTypeText, BT_TEXT_LEFT + BT_TEXT_BOTTOM, nOrientation)
         aTextSize := BT_DrawTextSize (hDC, ch, cFontName, nFontSize, nTypeText)
         AngleInc := BT_MathCircumferenceArcAngle ( Radius, aTextSize [1] ) 

         AngleDegrees :=  (AngleDegrees - AngleInc)
         nOrientation := INT (nOrientation - AngleInc)
      NEXT


      cText := "(c) Dr. Claudio Soto, August 2014, Uruguay"
      cFontName := "Times New Roman"
      nFontSize := 20
      nTypeText := BT_TEXT_BOLD + BT_TEXT_TRANSPARENT

      AngleDegrees := 183.5
      nOrientation := 90 

      FOR i := 1 TO HMG_LEN (cText)
         ch := HB_USUBSTR (cText, i, 1)
         nRow := Radius - BT_MathCircumferenceY (Radius, AngleDegrees) + OFFSET 
         nCol := Radius + BT_MathCircumferenceX (Radius, AngleDegrees) + OFFSET
         BT_DrawText (hDC, nRow, nCol, ch, cFontName, nFontSize, BLACK, NIL, nTypeText, BT_TEXT_LEFT + BT_TEXT_TOP, -nOrientation)
         aTextSize := BT_DrawTextSize (hDC, ch, cFontName, nFontSize, nTypeText)
         AngleInc := BT_MathCircumferenceArcAngle ( Radius, aTextSize [1] ) 

         AngleDegrees :=  (AngleDegrees + AngleInc)
         nOrientation := INT (nOrientation - AngleInc)
      NEXT

      BT_RegionCombine ( @hRgnDest, hRgn2, hRgn1, BT_REGION_DIFF )

      BT_SelectObject (hDC, hRgnDest)
      BT_DrawGradientFillVertical (hDC, 0, 0, Width, Height, RED, YELLOW)
      
      BT_DeleteObject (hRgn1)
      BT_DeleteObject (hRgn2)
      BT_DeleteObject (hRgnDest)
      
   BT_DeleteDC (BTstruct)
   
RETURN

***********************************************************************************
PROCEDURE SEARCH_OPEN()
***********************************************************************************
LOCAL Key_Search, Url_Search := URL_FORUM
LOCAL cPath := UPPER(Form_1.StatusBar.Item(1))+"\", cPath_

   IF UPPER(cFolderHMG+"\SAMPLES\") $ cPath
      cPath := StrTran(cPath,UPPER(cFolderHMG)+"\SAMPLES\","")

      IF !EMPTY(cPath)
         Key_Search := ""
         DO WHILE AT("\",cPath)>0
            cPath_ := LEFT(cPath,AT("\",cPath)-1)
            IF !(cPath_ $ [ADVANCED|APPLICATIONS|BASICS|CONTROLS|EVENTS|FUNCTIONS|HFCL|HPDF|MISCELLANEOUS|UNICODE])
               IF IsDigit(RIGHT(cPath_,1))
                  cPath_:=LEFT(cPath_,RAT("_",cPath_)-1)
               ENDIF
               IF !(cPath_ $ Key_Search)
                  Key_Search += "+"+cPath_
               ENDIF
            ENDIF
            cPath := SUBS(cPath,AT("\",cPath)+1)
         ENDDO
         IF !EMPTY(Key_Search)
            Url_Search := URL_FORUM + "/search.php?keywords="+Key_Search+"&ch=300"
         ENDIF
      ENDIF

   ENDIF

   URL_OPEN ( Url_Search )

RETURN



/*#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#define COBJMACROS

#include <windows.h>
#include <shlobj.h>
#include <math.h>
#include "hbapi.h"
#include "hbapiitm.h"



#pragma ENDDUMP
*/



